-- Upgrade script to 6.19 from 6.18.

-- Insert dataset property type enum elements
INSERT INTO DATASET_PROPERTY_TYPE(PROPERTY_ID, PROPERTY_NAME, PROPERTY_DATATYPE) VALUES (1, 'OrderByTimePeriodAsc', 'String')
;

INSERT INTO DATASET_PROPERTY_TYPE(PROPERTY_ID, PROPERTY_NAME, PROPERTY_DATATYPE) VALUES (2, 'OrderByTimePeriodDesc', 'String')
;

INSERT INTO DATASET_PROPERTY_TYPE(PROPERTY_ID, PROPERTY_NAME, PROPERTY_DATATYPE) VALUES (3, 'CrossApplyColumn', 'String')
;

INSERT INTO DATASET_PROPERTY_TYPE(PROPERTY_ID, PROPERTY_NAME, PROPERTY_DATATYPE) VALUES (4, 'CrossApplySupported', 'Boolean')
;

-- Copy existing DATASET.ORDER_BY_CLAUSE into DATASET_PROPERTY

INSERT
  INTO DATASET_PROPERTY (DATASET_ID, PROPERTY_TYPE_ENUM, PROPERTY_VALUE)
SELECT ds.DS_ID, dsp.PROPERTY_ID , LTRIM(REPLACE(LTRIM(CONVERT(NVARCHAR(4000), ds.ORDER_BY_CLAUSE)), 'ORDER BY', '' ))
  FROM DATASET ds
  JOIN DATASET_PROPERTY_TYPE dsp ON dsp.PROPERTY_NAME = 'OrderByTimePeriodAsc'
 WHERE ds.ORDER_BY_CLAUSE IS NOT NULL
;

-- always last
update DB_VERSION SET VERSION = '6.19'
;

